﻿Public Class Deltoide
    Dim RadioCG, RadioCE As Integer
    Dim Angulo_Circulo As Single = 90
    Dim Delta_Angulo As Single = 0.1
    Dim TrazoHipocicloide As New List(Of Point)

    Private Sub TmrAnima_Tick(sender As Object, e As EventArgs) Handles TmrAnima.Tick
        Angulo_Circulo += Delta_Angulo
        PictureBox1hipocicloide.Invalidate()
    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        TmrAnima.Enabled = False
    End Sub

    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles Button3.Click
        TmrAnima.Enabled = True
    End Sub

    Private Sub hipocicloide_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        TextBox1CG.Text = 90
        TextBox2CE.Text = 30
        TmrAnima.Enabled = False
    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        TrazoHipocicloide.Clear()
        PictureBox1hipocicloide.Refresh()
    End Sub

    Private Sub PicLienzo_Paint(sender As Object, e As PaintEventArgs) Handles PictureBox1hipocicloide.Paint
        RadioCG = CInt(TextBox1CG.Text)
        RadioCE = CInt(TextBox2CE.Text)

        'Ubicar el objeto en el centro del picture box
        e.Graphics.TranslateTransform(PictureBox1hipocicloide.ClientSize.Width / 2, PictureBox1hipocicloide.ClientSize.Height / 2)
        'Dibujamos El circulo Centrado en el origen
        e.Graphics.DrawEllipse(New Pen(Color.Black, 3), -RadioCG, -RadioCG, 2 * RadioCG, 2 * RadioCG)
        'Dibujamos circulo Externo que se va animar, girando al rededor del circulo fijo
        Dim X, Y As Single
        X = (RadioCG - RadioCE) * Math.Sin(Angulo_Circulo)
        Y = (RadioCG - RadioCE) * Math.Cos(Angulo_Circulo)
        e.Graphics.DrawEllipse(New Pen(Color.BlueViolet, 3), X - RadioCE, Y - RadioCE, 2 * RadioCE, 2 * RadioCE)
        'Colocamos el Lapiz Sobre el Circulo Externo, el lapiz dibujara la curva Hipocicloide
        Dim X1, Y1 As Single
        X1 = (RadioCG - RadioCE) * Math.Sin(Angulo_Circulo) + RadioCE * Math.Sin(Angulo_Circulo * (1 - (RadioCG / RadioCE)))
        Y1 = (RadioCG - RadioCE) * Math.Cos(Angulo_Circulo) + RadioCE * Math.Cos(Angulo_Circulo * (1 - (RadioCG / RadioCE)))
        e.Graphics.DrawLine(New Pen(Color.Gray, 3), X, Y, X1, Y1)
        'El Circulo Externo con el Lapiz Dijuba la curva parametrica Hipocicloide
        Dim Puntos As Point = New Point(X1, Y1)
        TrazoHipocicloide.Add(Puntos)
        For i = 1 To TrazoHipocicloide.Count - 1
            e.Graphics.DrawLine(New Pen(Color.OrangeRed, 4), TrazoHipocicloide(i), TrazoHipocicloide(i - 1))
        Next
    End Sub
End Class