﻿Imports System.Drawing.Drawing2D

Public Class lissajous
    Dim Frecuencia1, Frecuencia2, Fase1, Fase2 As Double
    Dim AnguloCirculo As Single = 90
    Dim Delta_Angulo As Single = 0.005
    Dim TrazoLissajous As New List(Of Point)

    Private Sub lissajous_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        TmrAnima.Enabled = True
        TextBox1Frecuencia.Text = 100
        TextBox2Frecuencia.Text = 60
        TextBoxFase1.Text = 100
        TextBoxFase2.Text = 20
    End Sub

    Private Sub TmrAnima_Tick(sender As Object, e As EventArgs) Handles TmrAnima.Tick
        AnguloCirculo += Delta_Angulo
        PictureBox1lissajous.Invalidate()
    End Sub

    Private Sub PicLienzo_Paint(sender As Object, e As PaintEventArgs) Handles PictureBox1lissajous.Paint
        Dim a1 As String
        a1 = Val(TextBox1Frecuencia.Text)
        Frecuencia1 = Val(a1)
        a1 = Val(TextBox2Frecuencia.Text)
        Frecuencia2 = Val(a1)
        a1 = Val(TextBoxFase1.Text)
        Fase1 = Val(a1)
        a1 = Val(TextBoxFase2.Text)
        Fase2 = Val(a1)

        MapeoVentanaGrafica(e.Graphics, -1.5, -1.5, 1.5, 1.5, 0, PictureBox1lissajous.ClientSize.Height - 1, PictureBox1lissajous.ClientSize.Width - 1, 0)

        Dim X, Y, Yant, Xant, t, tmax As Double
        e.Graphics.Clear(PictureBox1lissajous.BackColor)

        Dim Puntos As Point = New Point(Xant, Yant)
        TrazoLissajous.Add(Puntos)
        Dim Lapiz = New Pen(Color.OrangeRed, 0)
        t = 0 : tmax = 90 * Math.PI
        Xant = Math.Sin((2 * Math.PI * Frecuencia1 * t + Fase1) * Math.PI / 180)
        Yant = Math.Sin((2 * Math.PI * Frecuencia2 * t + Fase2) * Math.PI / 180)
        For t = 0 To AnguloCirculo Step Delta_Angulo
            X = Math.Sin((2 * Math.PI * Frecuencia1 * t + Fase1) * Math.PI / 180)
            Y = Math.Sin((2 * Math.PI * Frecuencia2 * t + Fase2) * Math.PI / 180)
            e.Graphics.DrawLine(Lapiz, CSng(Xant), CSng(Yant), CSng(X), CSng(Y))
            Xant = X
            Yant = Y
        Next

    End Sub


    Public Sub MapeoVentanaGrafica(ByVal g As Graphics, ByVal XVmin As Single, ByVal YVmin As Single, ByVal XVmax As Single, ByVal YVmax As Single, ByVal XPmin As Single, ByVal YPmin As Single, ByVal XPmax As Single, ByVal YPmax As Single)
        Dim Sx, Sy As Single
        'Este modulo mapea las coordenadas de la pantalla
        'Borramos cualquier transformacion que este activa

        g.ResetTransform()
        'Establecer las variables de escalamiento de la transformación
        Sx = CSng((XPmax - XPmin) / (XVmax - XVmin))
        Sy = CSng((YPmax - YPmin) / (YVmax - YVmin))

        'Realizamos la transformación

        g.ScaleTransform(Sx, Sy, MatrixOrder.Append)
        'Ubicamos el nuevo origen de coordenadas y trasladamos el origen

        g.TranslateTransform((XPmax + XPmin) / 2, (YPmax + YPmin) / 2, MatrixOrder.Append)


    End Sub
End Class