﻿Public Class cicloide

    Dim RadioCI, d As Integer
    Dim AnguloCirculo As Single = 0
    Dim Delta_Angulo = 0.1
    Dim TrazoEpitrocoide As New List(Of Point)

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        AnguloCirculo = 0
        TrazoEpitrocoide.Clear()
        PictureBox1cicloide.Refresh()
    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        TmrAnimar.Enabled = False
    End Sub

    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles Button3.Click
        TmrAnimar.Enabled = True
    End Sub

    Private Sub TmrAnimar_Tick(sender As Object, e As EventArgs) Handles TmrAnimar.Tick
        AnguloCirculo += Delta_Angulo
        PictureBox1cicloide.Invalidate()
    End Sub

    Private Sub cicloide_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        TextBoxradio.Text = 50
        TmrAnimar.Enabled = False
    End Sub

    Private Sub PicLienzo_Paint(sender As Object, e As PaintEventArgs) Handles PictureBox1cicloide.Paint
        Dim mitadAncho, mitadAlto, posIn As Integer
        mitadAncho = PictureBox1cicloide.ClientSize.Width
        mitadAlto = PictureBox1cicloide.ClientSize.Height / 2
        posIn = 430
        RadioCI = CInt(TextBoxradio.Text)


        'Nos ubicamos en el centro del picturebox
        e.Graphics.TranslateTransform(PictureBox1cicloide.ClientSize.Width / 2, mitadAlto)

        'Dibujamos el eje x
        e.Graphics.DrawLine(New Pen(Color.Black, 3), -mitadAncho, 0, 2 * mitadAlto, 0)

        'Dibujamos el circulo que es el que se va a animar girando alrededor de la recta
        Dim X, Y As Single
        X = RadioCI * (AnguloCirculo - Math.Sin(AnguloCirculo))
        Y = RadioCI * (1 - Math.Cos(AnguloCirculo))
        e.Graphics.DrawEllipse(New Pen(Color.BlueViolet, 3), (AnguloCirculo + X) - posIn, (0 - 2 * RadioCI), 2 * RadioCI, 2 * RadioCI)

        'Colocamos el lapiz sobre el circulo. El lapíz dibujara la curva cicloide
        Dim X1, Y1 As Single
        X1 = RadioCI + RadioCI * (AnguloCirculo - Math.Sin(AnguloCirculo))
        Y1 = -RadioCI * (1 - Math.Cos(AnguloCirculo))

        e.Graphics.DrawLine(New Pen(Color.Gray, 3), (AnguloCirculo + X + RadioCI) - posIn, (0 - RadioCI), X1 - posIn, Y1)

        'El extremo del lapiz dibuja la curva
        Dim Puntos As Point = New Point(X1 - posIn, Y1)
        TrazoEpitrocoide.Add(Puntos)
        For i = 1 To TrazoEpitrocoide.Count - 1
            e.Graphics.DrawLine(New Pen(Color.OrangeRed, 4), TrazoEpitrocoide(i), TrazoEpitrocoide(i - 1))
        Next
    End Sub
End Class