﻿Public Class epitrocoide

    Dim RadioCG, RadioCE, d As Integer
    Dim AnguloCirculo As Single = 90
    Dim Delta_Angulo As Single = 0.1
    Dim TrazoEpitrocoide As New List(Of Point)

    Private Sub epitrocoide_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        TextBox1CG.Text = 120
        TextBox2CE.Text = 60
        TextBox3D.Text = 15
        TmrAnimar.Enabled = False
    End Sub

    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles Button3.Click
        TmrAnimar.Enabled = True
    End Sub

    Private Sub TmrAnimar_Tick(sender As Object, e As EventArgs) Handles TmrAnimar.Tick
        AnguloCirculo += Delta_Angulo
        PictureBox1epitrocoide.Invalidate()
    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        TmrAnimar.Enabled = False
    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        TrazoEpitrocoide.Clear()
        PictureBox1epitrocoide.Refresh()

    End Sub


    Private Sub PicLienzo1_Paint(sender As Object, e As PaintEventArgs) Handles PictureBox1epitrocoide.Paint
        RadioCG = CInt(TextBox1CG.Text)
        RadioCE = CInt(TextBox2CE.Text)
        d = CInt(TextBox3D.Text)
        'Nos ubicamos en el centro del picturebox
        e.Graphics.TranslateTransform(PictureBox1epitrocoide.ClientSize.Width / 2, PictureBox1epitrocoide.ClientSize.Height / 2)
        'Dibujamos el circulo fijo
        e.Graphics.DrawEllipse(New Pen(Color.Black, 3), -RadioCG, -RadioCG, 2 * RadioCG, 2 * RadioCG)
        'Dibujamos el circulo externo que es el que se va a animar girando alrededor del circulo fijo
        Dim X, Y As Single
        X = (RadioCG + RadioCE) * Math.Sin(AnguloCirculo)
        Y = (RadioCG + RadioCE) * Math.Cos(AnguloCirculo)
        e.Graphics.DrawEllipse(New Pen(Color.BlueViolet, 3), X - RadioCE, Y - RadioCE, 2 * RadioCE, 2 * RadioCE)
        'Colocamos el lapiz sobre el circulo externo. El lapíz dibujara la curva Epitrocoide
        Dim X1, Y1 As Single
        X1 = (RadioCG + RadioCE) * Math.Sin(AnguloCirculo) - d * Math.Sin(((RadioCG + RadioCG + RadioCE) / RadioCE) * AnguloCirculo)
        Y1 = (RadioCG + RadioCE) * Math.Cos(AnguloCirculo) - d * Math.Cos(((RadioCG + RadioCG + RadioCE) / RadioCE) * AnguloCirculo)
        e.Graphics.DrawLine(New Pen(Color.Gray, 3), X, Y, X1, Y1)
        'El extremo del lapiz dibuja la curva parametrica epitrocoide
        Dim Puntos As Point = New Point(X1, Y1)
        TrazoEpitrocoide.Add(Puntos)
        For i = 1 To TrazoEpitrocoide.Count - 1
            e.Graphics.DrawLine(New Pen(Color.OrangeRed, 4), TrazoEpitrocoide(i), TrazoEpitrocoide(i - 1))
        Next
    End Sub

End Class