﻿Public Class hipotrocoide

    ' Dim G As System.Drawing.Graphics
    Dim RadioCG, RadioCI, d As Integer
    Dim AnguloCirculo As Single = 90
    Dim Delta_Angulo = 0.1
    Dim TrazoHipotrocoide As New List(Of Point)

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        TrazoHipotrocoide.Clear()
        PictureBox1hipotrocoide.Refresh()
    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        TmrHipotrocoide.Enabled = False
    End Sub

    Private Sub hipotrocoide_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        TextBox1CG.Text = 100
        TextBox2CI.Text = 60
        TextBox3D.Text = 100
        TmrHipotrocoide.Enabled = False
    End Sub

    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles Button3.Click
        Me.SetStyle(ControlStyles.AllPaintingInWmPaint Or ControlStyles.UserPaint Or ControlStyles.OptimizedDoubleBuffer, True)
        PictureBox1hipotrocoide.Refresh()
        TmrHipotrocoide.Enabled = True
    End Sub

    Private Sub PicLienzo_Paint(sender As Object, e As PaintEventArgs) Handles PictureBox1hipotrocoide.Paint
        RadioCG = CInt(TextBox1CG.Text)
        RadioCI = CInt(TextBox2CI.Text)
        d = CInt(TextBox3D.Text)

        'Nos ubicamos en el centro del picturebox
        e.Graphics.TranslateTransform(PictureBox1hipotrocoide.ClientSize.Width / 2, PictureBox1hipotrocoide.ClientSize.Height / 2)
        'Dibujamos el circulo fijo
        e.Graphics.DrawEllipse(New Pen(Color.Black, 3), -RadioCG, -RadioCG, 2 * RadioCG, 2 * RadioCG)
        'Dibujamos el circulo interno que es el que se va a animar girando alrededor del circulo fijo
        Dim X, Y As Single
        X = (RadioCG - RadioCI) * Math.Sin(AnguloCirculo)
        Y = (RadioCG - RadioCI) * Math.Cos(AnguloCirculo)
        e.Graphics.DrawEllipse(New Pen(Color.BlueViolet, 3), X - RadioCI, Y - RadioCI, 2 * RadioCI, 2 * RadioCI)
        'Colocamos el lapiz sobre el circulo INTERNO. El lapíz dibujara la curva hipotrocoide
        Dim X1, Y1 As Single
        X1 = (RadioCG - RadioCI) * Math.Cos(AnguloCirculo) + d * Math.Cos(((RadioCG - RadioCI) / RadioCI) * AnguloCirculo)
        Y1 = (RadioCG - RadioCI) * Math.Sin(AnguloCirculo) - d * Math.Sin(((RadioCG - RadioCI) / RadioCI) * AnguloCirculo)
        e.Graphics.DrawLine(New Pen(Color.Gray, 3), X, Y, X1, Y1)
        'El extremo del lapiz dibuja la curva parametrica Hipotrocoide
        Dim Puntos As Point = New Point(X1, Y1)
        TrazoHipotrocoide.Add(Puntos)
        For i = 1 To TrazoHipotrocoide.Count - 1
            e.Graphics.DrawLine(New Pen(Color.OrangeRed, 4), TrazoHipotrocoide(i), TrazoHipotrocoide(i - 1))
        Next

    End Sub

    Private Sub TmrHipotrocoide_Tick(sender As Object, e As EventArgs) Handles TmrHipotrocoide.Tick
        AnguloCirculo += Delta_Angulo
        PictureBox1hipotrocoide.Invalidate()
        PictureBox1hipotrocoide.Refresh()
    End Sub
End Class